import { ElementRef, EventEmitter, InjectionToken, NgZone, type OnDestroy, type OnInit } from '@angular/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export type NgxResizeOptions = {
    box: ResizeObserverBoxOptions;
    debounce: number | {
        scroll: number;
        resize: number;
    };
    scroll: boolean;
    offsetSize: boolean;
    emitInZone: boolean;
    emitInitialResult: boolean;
};
export declare const defaultResizeOptions: NgxResizeOptions;
export declare const NGX_RESIZE_OPTIONS: InjectionToken<NgxResizeOptions>;
export declare function provideNgxResizeOptions(options?: Partial<NgxResizeOptions>): {
    provide: InjectionToken<NgxResizeOptions>;
    useValue: {
        box: ResizeObserverBoxOptions;
        debounce: number | {
            scroll: number;
            resize: number;
        };
        scroll: boolean;
        offsetSize: boolean;
        emitInZone: boolean;
        emitInitialResult: boolean;
    };
};
export type NgxResizeResult = {
    readonly entries: ReadonlyArray<ResizeObserverEntry>;
    readonly x: number;
    readonly y: number;
    readonly width: number;
    readonly height: number;
    readonly top: number;
    readonly right: number;
    readonly bottom: number;
    readonly left: number;
    readonly dpr: number;
};
export declare function injectNgxResize(options?: Partial<NgxResizeOptions>): Observable<NgxResizeResult>;
export declare class NgxResize implements OnInit, OnDestroy {
    private readonly host;
    private readonly zone;
    private readonly document;
    private readonly resizeOptions;
    ngxResizeOptions: Partial<NgxResizeOptions>;
    ngxResize: EventEmitter<NgxResizeResult>;
    constructor(host: ElementRef<HTMLElement>, zone: NgZone, document: Document, resizeOptions: NgxResizeOptions);
    private sub?;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxResize, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxResize, "[ngxResize]", never, { "ngxResizeOptions": { "alias": "ngxResizeOptions"; "required": false; }; }, { "ngxResize": "ngxResize"; }, never, never, true, never>;
}
